// mutex.go - mutex, no race condition
package main  
import ( "fmt"; "sync")

var number int
var wg sync.WaitGroup
var mutex sync.Mutex 

func update(val int) {  
    defer wg.Done()
    mutex.Lock()
    number += val
    mutex.Unlock()
}

func main() {  
    wg.Add(100)        
    for i := 0; i < 100; i++ {
        go update(1)
    }
    wg.Wait()
    fmt.Println(number)
}
/*************************************

    $ go run mutex.go
    100

    $ go run -race mutex.go
    100

*/
