// pipeline.go - goroutine channels connected together
package main
import "fmt"

func main() {
    data := make(chan int)      // data channel
    filter := make(chan int)    // filter channel

    nums := []int { 34, -7, 72, 11, -23, -59, 88, 66, -43 }

    go func() {
        for i := range nums {
            data <- nums[i]
        }
        close(data)
    }()

    go func() {
        for num := range data {
            if num > 0 { filter <- num }
        }
        close(filter)
    }()

    for num := range filter {
        fmt.Printf("%d ", num)
    }
    fmt.Println()
}

/*************************************

    $ go run pipeline.go
    34 72 11 88 66 

*/
