// race.go - race condition
package main  
import ( "fmt"; "sync")

var number int
var wg sync.WaitGroup

func update(val int) {  
    defer wg.Done()
    number += val
}

func main() {  
    wg.Add(100)        
    for i := 0; i < 100; i++ {
        go update(1)
    }
    wg.Wait()
    fmt.Println(number)
}
/*************************************

    $ go run race.go
    98
    
    $ go run -race race.go
    ==================
    WARNING: DATA RACE
    Read at 0x000001211840 by goroutine 7:
        main.update()
            /Users/paul/go/race.go:10 +0x66

    Previous write at 0x000001211840 by goroutine 6:
        main.update()
            /Users/paul/go/race.go:10 +0x87

    Goroutine 7 (running) created at:
        main.main()
            /Users/paul/go/race.go:16 +0x71

    Goroutine 6 (finished) created at:
        main.main()
            /Users/paul/go/race.go:16 +0x71
    ==================
    100
    Found 1 data race(s)
    exit status 66

*/
