// rangeclose.go - send, rcv with range, unbuf channel
package main
import ("fmt"; "sync")

var wg sync.WaitGroup

func main() {
    wg.Add(2)                  // add goroutines

    ch := make(chan string)    // unbuffered channel
    go sendMessages(ch)
    go getMessages(ch)

    wg.Wait()                  // wait for goroutines to finish
}

func sendMessages(ch chan string) {
    defer wg.Done()    
    messages := []string { "Message 1", "Message 2", "Message 3" }
    for _, msg := range messages {
        ch <- msg
    }
    close(ch)                  // end of messages
}

func getMessages(ch chan string) {
    defer wg.Done()
    for msg := range ch {
        fmt.Println(msg)
    }
}

/*************************************

    $ go run rangeclose.go
    Message 1
    Message 2
    Message 3

*/
